﻿package {
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.display.DisplayObject;
	/////
	import flash.utils.getTimer;
	import flash.geom.*;
	import flash.geom.ColorTransform;
	import flash.filters.BitmapFilterQuality;
	import flash.filters.GlowFilter;
	import flash.events.EventDispatcher;
	/////
	public class Physics extends Sprite {

		private var nbr:Number=10;// Nombre de boules
		/////
		private var downPoint:Point;
		private var upPoint:Point;
		private var startTime:int;
		private var endTime:int;
		private var dx:Number;
		private var dy:Number;
		private var distance:Number;
		private var modulo:Number=100;
		private var inv:Number=1;
		/////
		public function Physics() {

			/////
			if (modulo % 200 == 0) {
				inv*= -1;
			}
			modulo += inv;
			/////

			for (var i:Number=0; i < nbr; i++) {
				var ball:Ball=new Ball;
				ball.x=300;
				ball.y=300;
				ball.name="ball" + i;
				
				//ball.dispatchEvent(ball);
				//trace(ball.dispatchEvent);
				
				/////
				var glow:GlowFilter = new GlowFilter();
				glow.color = 0x660066;
				glow.alpha = 1;
				glow.blurX = modulo;
				glow.blurY = modulo;
				glow.quality = BitmapFilterQuality.HIGH;

				ball.filters = [glow];
				/////

				addChild(ball);
			}
			//sécurité pour être sûr que le stage a été ajouter sur le stage
			addEventListener(Event.ADDED_TO_STAGE,added_handler);

		}
		private function added_handler(e:Event):void {

			//addEventListener(MouseEvent.CLICK,click_handler);
			for (var i:Number=0; i < nbr; i++) {
				var ball:DisplayObject=getChildByName("ball" + i);
				ball.addEventListener(MouseEvent.MOUSE_UP,upHandler);
				ball.addEventListener(MouseEvent.MOUSE_DOWN,downHandler);
				/////
				downPoint=new Point  ;
				upPoint=new Point  ;
				/////
			}
		}
		private function downHandler(e:MouseEvent):void {

			/////
			downPoint.x=mouseX;
			downPoint.y=mouseY;
			startTime=getTimer();
			/////
			e.currentTarget.removeEventListener(Event.ENTER_FRAME,e.currentTarget.enter_handler_down);
			e.currentTarget.removeEventListener(Event.ENTER_FRAME,e.currentTarget.enter_handler_up);
			e.currentTarget.removeEventListener(Event.ENTER_FRAME,e.currentTarget.enter_handler_left);
			e.currentTarget.removeEventListener(Event.ENTER_FRAME,e.currentTarget.enter_handler_right);
			e.currentTarget.startDrag();

		}
		public function upHandler(e:MouseEvent):void {

			e.currentTarget.stopDrag();

			/////

			upPoint.x=mouseX;
			upPoint.y=mouseY;
			dx=upPoint.x - downPoint.x;
			dy=upPoint.y - downPoint.y;
			var angle=180 / Math.PI * Math.atan2(dy,dx) + 180;
			distance=Point.distance(upPoint,downPoint);
			endTime=getTimer();
			var deltaTime:int = endTime - startTime;
			//trace(distance);
			//trace(angle);
			trace(deltaTime);

			/////

			if (angle > 45 && angle < 135) {

				e.currentTarget.removeEventListener(Event.ENTER_FRAME,e.currentTarget.enter_handler_down);
				e.currentTarget.removeEventListener(Event.ENTER_FRAME,e.currentTarget.enter_handler_left);
				e.currentTarget.removeEventListener(Event.ENTER_FRAME,e.currentTarget.enter_handler_right);
				e.currentTarget.addEventListener(Event.ENTER_FRAME,e.currentTarget.enter_handler_up);

			} else if (angle > 225 && angle < 315) {

				e.currentTarget.removeEventListener(Event.ENTER_FRAME,e.currentTarget.enter_handler_up);
				e.currentTarget.removeEventListener(Event.ENTER_FRAME,e.currentTarget.enter_handler_left);
				e.currentTarget.removeEventListener(Event.ENTER_FRAME,e.currentTarget.enter_handler_right);
				e.currentTarget.addEventListener(Event.ENTER_FRAME,e.currentTarget.enter_handler_down);

			} else if (angle > 135 && angle < 225) {

				e.currentTarget.removeEventListener(Event.ENTER_FRAME,e.currentTarget.enter_handler_left);
				e.currentTarget.removeEventListener(Event.ENTER_FRAME,e.currentTarget.enter_handler_up);
				e.currentTarget.removeEventListener(Event.ENTER_FRAME,e.currentTarget.enter_handler_down);
				e.currentTarget.addEventListener(Event.ENTER_FRAME,e.currentTarget.enter_handler_right);

			} else if (angle > 0 && angle < 45 || angle > 315 && angle < 360) {

				e.currentTarget.removeEventListener(Event.ENTER_FRAME,e.currentTarget.enter_handler_right);
				e.currentTarget.removeEventListener(Event.ENTER_FRAME,e.currentTarget.enter_handler_up);
				e.currentTarget.removeEventListener(Event.ENTER_FRAME,e.currentTarget.enter_handler_down);
				e.currentTarget.addEventListener(Event.ENTER_FRAME,e.currentTarget.enter_handler_left);

			}
			/////

			if (angle > 45 && angle < 135) {

				e.currentTarget.width += distance / 10 * deltaTime / 100;
				e.currentTarget.height+= distance / 10 * deltaTime / 100;
				e.currentTarget.transform.colorTransform=new ColorTransform(deltaTime-(240*Math.random()), deltaTime,0,1,0,1,0,0);

			} else if (angle > 225 && angle < 315) {

				e.currentTarget.width -= distance / 10 * deltaTime / 100;
				e.currentTarget.height-= distance / 10 * deltaTime / 100;
				e.currentTarget.transform.colorTransform=new ColorTransform(deltaTime, deltaTime-(240*Math.random()), 0,1,0,1,0,0);

			} else if (angle > 135 && angle < 225) {

				e.currentTarget.transform.colorTransform=new ColorTransform(deltaTime, deltaTime-(220*Math.random()), 0,1,0,1,0,0);
				//ball.rotation

			} else if (angle > 0 && angle < 45 || angle > 315 && angle < 360) {

				e.currentTarget.transform.colorTransform=new ColorTransform(deltaTime-(220*Math.random()), deltaTime, 0, 1,0,1,0,0);

			}
			/////
		}
	}
}

import flash.display.Sprite;
import flash.events.Event;
import flash.display.Shape;

class Ball extends Sprite {
	/*
	Calcul de la vitesse par rapport à l'accélération
	Mise en place d'obstacles sur la chute pour faire "rebond"
	*/
	private var speedy:Number;
	private var speedx:Number;
	private var friction:Number;
	private var ax:Number;
	private var ay:Number;
	private var gravity:Number;

	public function Ball() {

		/*var circle1:Shape = new Shape();
		circle1.graphics.beginFill(0x0000FF);
		circle1.graphics.drawCircle(0, 0, 40);
		addChild(circle1);
		
		var circle2:Shape = new Shape();
		circle2.graphics.beginFill(0x00FF00);
		circle2.graphics.drawCircle(0, 0, 40);
		addChild(circle2);
		
		trace(circle1.hitTestObject(circle2)); // true*/
		
		graphics.beginFill(0xffffff,.3);
		graphics.drawCircle(0,0,30);
		/*graphics.moveTo(0,0);
		graphics.lineTo(10,0);
		graphics.lineTo(10,40);
		graphics.lineTo(25,0);
		graphics.lineTo(35,0);
		graphics.lineTo(15,50);
		graphics.lineTo(35,90);
		graphics.lineTo(25,90);
		graphics.lineTo(10,60);
		graphics.lineTo(10,90);
		graphics.lineTo(0,90);
		graphics.lineTo(0,0);
		graphics.endFill();*/
		initialisation();
		addEventListener(Event.ENTER_FRAME,enter_handler_down);
	}
	public function initialisation():void {

		speedy=Math.random() * 10;
		speedx=Math.random() * 10;
		friction=0.99;
		ax=0;
		ay=0;
		gravity=0.9;
	}
	public function enter_handler_down(e:Event):void {//calcul physique des mouvements

		speedy+= gravity;// à la vitesse vertical on aditionne la gravité
		speedy+= ay;// à la vitesse vertical on additionne l'accélération
		speedx+= ax;// à la vitesse horizontal on additionne l'accélération (il n'y a pas de gravité à l'horizontal)
		speedy*= friction;// on multiplie la vitesse vertical par la friction (le freinage, l'effet de rebond)
		speedx*= friction;// on multiplie la vitesse horizontale par la friction (le freinage, l'effet de rebond)
		e.currentTarget.y+= speedy;// on se déplace verticalement en rapport à la vitesse verticale calculée
		e.currentTarget.x+= speedx;// on se déplace horizontalement en rapport à la vitesse horizontale calculée

		//si on touche les bords, on rebondit

		if (e.currentTarget.y + e.currentTarget.height / 2 > stage.stageHeight) {
			e.currentTarget.y=stage.stageHeight - e.currentTarget.height / 2;
			speedy*= -1;
		}
		if (e.currentTarget.x + e.currentTarget.width / 2 > stage.stageWidth) {
			e.currentTarget.x=stage.stageWidth - e.currentTarget.width / 2;
			speedx*= -1;
		} else if (e.currentTarget.x - e.currentTarget.width / 2 < 0) {
			e.currentTarget.x=e.currentTarget.width / 2;
			speedx*= -1;
		}
	}
	public function enter_handler_up(e:Event):void {//calcul physique des mouvements

		speedy+= gravity;// à la vitesse vertical on aditionne la gravité
		speedy+= ay;// à la vitesse vertical on additionne l'accélération
		speedx+= ax;// à la vitesse horizontal on additionne l'accélération (il n'y a pas de gravité à l'horizontal)
		speedy*= friction;// on multiplie la vitesse vertical par la friction (le freinage, l'effet de rebond)
		speedx*= friction;// on multiplie la vitesse horizontale par la friction (le freinage, l'effet de rebond)
		e.currentTarget.y-= speedy;// on se déplace verticalement en rapport à la vitesse verticale calculée
		e.currentTarget.x-= speedx;// on se déplace horizontalement en rapport à la vitesse horizontale calculée

		//si on touche les bords, on rebondit

		if (e.currentTarget.y - e.currentTarget.height / 2 < 0) {
			e.currentTarget.y = 0 + e.currentTarget.height / 2;
			speedy*= -1;
		}
		if (e.currentTarget.x + e.currentTarget.width / 2 > stage.stageWidth) {
			e.currentTarget.x=stage.stageWidth - e.currentTarget.width / 2;
			speedx*= -1;
		} else if (e.currentTarget.x - e.currentTarget.width / 2 < 0) {
			e.currentTarget.x=e.currentTarget.width / 2;
			speedx*= -1;
		}
	}
	public function enter_handler_right(e:Event):void {//calcul physique des mouvements

		speedx+= gravity;// à la vitesse vertical on aditionne la gravité
		speedy+= ay;// à la vitesse vertical on additionne l'accélération
		speedx+= ax;// à la vitesse horizontal on additionne l'accélération (il n'y a pas de gravité à l'horizontal)
		speedy*= friction;// on multiplie la vitesse vertical par la friction (le freinage, l'effet de rebond)
		speedx*= friction;// on multiplie la vitesse horizontale par la friction (le freinage, l'effet de rebond)
		e.currentTarget.y+= speedy;// on se déplace verticalement en rapport à la vitesse verticale calculée
		e.currentTarget.x+= speedx;// on se déplace horizontalement en rapport à la vitesse horizontale calculée

		//si on touche les bords, on rebondit

		if (e.currentTarget.y + e.currentTarget.height / 2 > stage.stageHeight) {
			e.currentTarget.y=stage.stageHeight - e.currentTarget.height / 2;
			speedy*= -1;
		} else if (e.currentTarget.y + e.currentTarget.height / 2 < 0) {
			e.currentTarget.y=0 + e.currentTarget.height / 2;
			speedy*= -1;
		}
		if (e.currentTarget.x + e.currentTarget.width / 2 > stage.stageWidth) {
			e.currentTarget.x=stage.stageWidth - e.currentTarget.width / 2;
			speedx*= -1;
		}
	}
	public function enter_handler_left(e:Event):void {//calcul physique des mouvements

		speedx+= gravity;// à la vitesse vertical on aditionne la gravité
		speedy+= ay;// à la vitesse vertical on additionne l'accélération
		speedx+= ax;// à la vitesse horizontal on additionne l'accélération (il n'y a pas de gravité à l'horizontal)
		speedy*= friction;// on multiplie la vitesse vertical par la friction (le freinage, l'effet de rebond)
		speedx*= friction;// on multiplie la vitesse horizontale par la friction (le freinage, l'effet de rebond)
		e.currentTarget.y-= speedy;// on se déplace verticalement en rapport à la vitesse verticale calculée
		e.currentTarget.x-= speedx;// on se déplace horizontalement en rapport à la vitesse horizontale calculée

		//si on touche les bords, on rebondit

		if (e.currentTarget.y + e.currentTarget.height / 2 > stage.stageHeight) {
			e.currentTarget.y=stage.stageHeight - e.currentTarget.height / 2;
			speedy*= -1;
		} else if (e.currentTarget.y + e.currentTarget.height / 2 < 0) {
			e.currentTarget.y=0 + e.currentTarget.height / 2;
			speedy*= -1;
		}
		if (e.currentTarget.x - e.currentTarget.width / 2 < 0) {
			e.currentTarget.x=e.currentTarget.width / 2;
			speedx*= -1;
		}
	}
}